History

16th November 1999
------------------

Re-built the wordlist for the USA dictionary
Re-sampled the sounds that sounded like they were being played down the toilet


15th November 1999
------------------

More words sampled in preperation for the next release. Only wordset D to finish off now.


Saturday 6th November 1999
--------------------------

Sampled lots more from the real Speak&Spell, samples are about 33% complete now.
Re-organised wordset A.
USASS now works 100% with wordset A.(Spell and SAY IT)
Mystery word works 100%
Secret code works 100%
Letter ??? works 100%
Clue works 100%
Repeat works 100%


Friday 5th November 1999
------------------------

Samples lots of sounds from the USA Speak&Spell, and threw them into sass, which worked like a charm!
Started to re-organise the word list ready for the new word sets once they are sampled


Thursday 4th November 1999
--------------------------

Has it been THAT long since I updated this file? (Ooops!) :-)
Recieved Speak&Math, USA Speak&Spell, and Speak&Read in the mail, and got to work on a real USA SASS (not a butchered sounds one like i was working on)


Thursday 8th July 1999
----------------------

Decided to fix a few bits and pieces which a few people had emailed about, and as I was working on Wizard, and took
the opportunity to fix them whilst I had the chance.

Fixed Bug in Hangman: If you pressed 'ENTER', the last _ on the line would dissapear, until there are no letters
left and then the program crashed out with "Runtime error 7"

Fixed bug in Secret Code: If you pressed enter after pressing no letters, or Erase and then typed a letter, SASS
gave a nasty error and quit.

Did some other adjustments, and general tidying up.

Replaced Led_real font with a newer version created especially for SASS by Matthew Welch, which reflects a real
Speak&Spell almost PERFECTLY! (To be fair, he sent me that font about 1 hour after V1.1 was released, but it has
taken me until now to implement it)


Thursday 27th May 1999
----------------------

Released PR1.1 3 days late but worth the wait ':-)


Monday 24th May 1999
--------------------

Release for PR1.1 went TOTALLY wrong, so I released RC1 to the public as an untested beta, which went down well(ish).


Sunday 23rd May 1999
--------------------

Fixed the scoring system completely, now it says your score as it should on the real thing.

Created the SASS install setup file, which seems to install the font and make a shortcut in the start menu
for SASS, which seems to work really well (It had better, at time of writing we're 7 hours from release!)

Fingers crossed, here goes PR V1.1!


Thursday 20th May 1999
----------------------

Finally finished the remainin samples, including numbers 1 - 10, all the words and a few words which I missed from before!

Re-organised the words() databse

There seems to be a minor problem with the score results, the numbers do not appear to work, but this is being fixed, so
ignore it on RC1

V1.1 RC1 sent out to beta testers.

Tuesday 18th May 1999
---------------------

Discarded use of individual wave files! SASS now compiles to a single exe of which all the sounds are included.
Completely changed the way SASS Plays sounds, now more efficient and time control is far better.
(Both thanks to Andy Twiss)



Monday 17th May 1999
--------------------

Recovered last of the source code and cleaned up the remaining samples.

Put together a new beta, but more than half the samples are missing. If you unzip over a copy of PR1, then it will use old samples
in place of missing new ones, but I wouldnt recommend it.

Samples recovered:

Letters A-Z
Some numbers
Some words of word set A
Most prompts, IE spell, you win, I win, etc, so Mystery Word and SPELL A still work 95%, all modes that dont use words can
still be used.

Experimented with putting all the samples into a dll, which seems to work (Thanks to Andy Twiss)

Experimental User directory (not included in beta)

Backed up what source code I have still got onto CD-ROM, just in case!

Found yet ANOTHER Speak&Spell, from my nextdoor neighbour! No headphone socket, and no battery cover.


Saturday 15th May 1999
----------------------

Re-Installed most things at last and managed to rescue 99% of the source code, the only things we lost were a few minor
changes, which I think I can salvage, but I dont think this will make a release any faster.

Changed the font size and background image, this now reflects the real speak&spell more faithfully, but it needs some
adjustment on the colour of the font.

Discovered that the real Speak&Spell wont actually turn off in "Say It" mode. The only buttons that work in this mode are
"Mystery Word" "Secret Code" "Letter" "Say It" and "Spell", so maybe I've fixed a bug that wasnt actually a bug!

Adam Jervis, one of our beta testers has acquired another speak&spell! It seems to be an older version with no headphone socket
built in and some of the words and sounds seem to be slightly different.

Came across our first problem since the crash, The exe is refusing to run on anything other than my machine and is reporting
some popupmenu error in an "unresolved external reference", which is frustrating as there is NO popupmenu.


Friday 14th May 1999
--------------------

We almost lost the entire SASS project today! Don't you just LOVE hard drive crashes? I honestly thought at one point that
the source code for SASS had gone for good, but after 3hours of scandisking and xcopying and reinstalling etc, we have
it all (I think) back. Some of the new samples have gone, I hope I can get the recording levels back to how they were
otherwise we're going to have a lovely uneven set of sounds!

I also didnt enjoy renaming everything back to windows file names from nowspe~1.wav etc, that was MOST distressing.

One thing for certain: Forget mondays release, sorry but it just isnt going to happen. This crash has set me back at
least 2 days, so I think wednesday at the earliest, unless I can rescue more of the source.


Wednesday 12th May 1999
-----------------------

I recieved an icon in the mail today which I thought was fantastic, and shall be using for all subsequent builds of
SASS from here on. Big thanks to Ben schuster for that icon, even small things like that make a lot of difference.

I have a lot of the new samples now done, all of the letters, wordset A, most commands, the on sounds, and half of
wordset B, although the sounds arent brilliant, they are a vast improvement on the original sounds that we used.

The timing has had to be fixed completely, this means that SASS is now incompatible with the old sound set, and the
new one MUST be downloaded for use with the next release, but it IS worth it, I ran V1.0.0 next to this beta and the
improvements are totally unbelievable.

I learned a good lesson today - Don't start something you dont mean to continue, this project has gone from a joke to
a labour of love. Re sampling 300+sounds is no fun at all, but its worth it.

Re-wrote the scoring code to now use numbers and "say" your score rather than just print it on the screen (unless you 
get 10/10 in which case you get "perfect score")

Replaced both images on the opening and closing splash screens to a nicer transparent one.

As soon as all the words are sampled, as long as nobody finds anything really nasty (nobody has yet) then the next private
release is going to be V1.1RC1
 

Tuesday 11th May 1999
---------------------
Aparently we hit 10,000 visitors on the website today! That's not bad going for a 9 day old website 
for a 12 day old program.

The real Speak&Spell has a cursor, an _ underscore which follows anything you type during the Spell mode,
Secret Code and Letter ??? modes. This is now implemented but it isnt perfect yet (I think).

Re-wrote the way that SASS handles the alphabet, Originally it used 27 (A-Z and ') copies of
_________________________
Private sub A_onclick()
If blah then 
this
If etc..


End Sub
__________________________
Which made things very messy when I tried to add the cursor code, so now each letter press calls insertchar(character as string)
which means one version and hopefully no more broken letters.

Took out the debug "total = 9", which meant spell game only needed 1 right or wrong answer to complete.

Made the cursor "flash" at the correct time. For instance right before saying the word, the display would refresh, making
the cursor "flash" off for a few seconds, so I simulated that.

The way S&S displays the words is a lot different that i originally thought. I've tried to make SASS replicate this, the words
now stay on screen for longer in most cases but this seems to have caused minor problems with the timing of some speech.

SASS now fades the display at appropriate moments (display changing etc) but isnt noticable enough yet.

Changed the colour of the digital text to match (as closely as possible) the real S&s.


Sunday 9th May 1999
-------------------

Got the real Speak&Spell back (after a minor disagreement), so I started sampling the words again using the headphone socket
directly into my soundcard, which has made quite an impressive difference to the overall sound quality.

Updated readme.txt

Changed the image to display "Speak & Spell Simulator" rather than Speak & Spell.

Changed the transparency border to make more of the image visible.

Tried to add a sass.ini, which immediately fell over. Potentially this could allow people to add their own words and sounds.

Fixed bug which preventing spell game from ending is score was 10/10 (I must have broken this when i fixed the opposite).


Saturday 8th May 1999
---------------------

Managed to get through 99% of all the emails and set about thinking about considering doing something about some minor problems.

Completely re-wrote the dragging form code, which now works 500% more efficiently (possibly more).

Added Keyboard support:

Esc = Off
F1 = Go
F2 = Replay (Still not implemented)
F3 = Repeat
F4 = Clue
F5 = Mystery Word
F6 = Secret Code
F7 = Letter ???
F8 = Say It
F9 (Or Space) = ON/Spell game
Backspace or Delete = Erase
Enter = Enter
A-Z and ' are mirrored (So pressing A on the keyboard is like pressing A on the real thing etc)

Added code which prevented words from being repeated on say it and spell modes (yes, this WAS a bug, I was just too lazy to fix it
before V1.0.0 was released) 

Fixed problem with buttons not working on certain machines, some people were experiencing weird effects with the buttons 
not responding properly.


Friday 7th May 1999
-------------------

Released V1.0.0 to the general public and celebrated!


Thursday 6th May 1999
---------------------

Fixed Bug in Mystery word that preventing A-D being selected on SAY IT mode

Added a faded LED display for authenticity

Released RC2


Wednesday 5th May 1999
----------------------

Transparency effects and dragging Speak and Spell, HUGE thanks to Andy Twiss!

Fixed SAYIT so it doesnt lock up anymore!

FIXED word(144) playing as a beep

FIXED bug in the Hangman game giving you the answer and saying "I WIN" followed by "YOU WIN"

FIXED bug in SPELL that showed the wrong score if you got 10 out of 10

NEW image, its sharper, easier to read and looks MUCH nicer

FIXED bug on the ON button that made the ENTER key do weird stuff if you pressed it when it wasnt supposed to be active

I think we have a Release Candidate! OK Beta testers, pull it to pieces!



Tuesday 4th May 1999
--------------------

All word sets now complete from A to D 100%

Hangman game working with all wordsets 100%

Say it working with ALL wordsets 100%

Spell games A to D working 100%

Project Ready for public release? Maybe not! Say it game still locks the machine up! Choice: Remove say it game or
Fix the timer. I dont know how to fix the timer and i dont want to remove the mode, so looks like we'll be delayed.

Apart from the say it mode, I can honestly say that the program is running VERY close to the real speak and spell! I
honestly didnt expect anything this good (or fast) to happen!

I'd like to make the background transparent, and remove the nasty black border that is on the screen at the moment,
but I have no idea how to do it and this VB "books online" doesnt seem to have a "Programming a Speak and Spell
Simulator" section in it!!!!



Monday 3rd May 1999
-------------------

Got a LED font to use! looks fantastic, big thanks to Matthew Welch (http://home.att.net/~daffy-duck)

Clue button now works

Made "'" (apostrophe button) work

Guess the word game (hangman) is now complete

Fixed the scoring on Spell mode, now gives you score!

The "Say it" game still locks the machine up, I think its to do with the way the timer works. So if you dont want to say 10
words, then DONT USE IT!!

Looks like we'll be ready for that release on tuesday after all! :-)


Sunday 2nd May 1999
-------------------

Website now online at:
Http://listen.to/sass (thanks to sharon)

Changed the splash screen so that it didnt fall over if it lost focus

"Code" game now works 100%, which is nice.

Began work on the guess the letter "Hangman" game and got it working almost immediately! clue button doesnt work yet,
but the game works, infinite guesses at the moment, so you are guaranteed to win!

"Letter" button now works, it puts a random letter in the display, then switches to "CODE" game.

Sampled more sounds, we now have numbers 1 - 10, "you win" "i win" and others..

Scoring system now works! Prefect score sounds are there and working! Get any wrong and you get nothing! (for now)

I think that makes over 50% of the whole thing complete, which means we could have a
public release by tuesday... (I'm not promising anything)



Saturday 1st May 1999
---------------------

"Say It" now works, but seems to lock the whole thing up so you cant use anything else. "Say it" spits out 10 words
one after another, and on this machine locks the whole thing up, so you can only escape with ctrl+break (in debug)
or ctrl+alt+del in runtime, which is a bit weird, but at least it only lasts for 10 words, then goes on to "Spell"
game, which i *think* uses the 10 words just used on say it, but i'm not too sure.

Started experimental work on "CODE" game, not far off being complete. The "code" game just replaces whatever you
type with an alternate Letter of the alphabet when you press "Enter". Not very diffucult code to crack, but 
generates weird characters for me at the moment.

Began work on the scoring system, but game "spell" still goes on forever and never gives a score

Started sampling word set "B"

Bought new batteries for the real speak and spell!

Aparently, Sharon posted yesterdays beta on a server for the beta testers to get! (Nice of her to ask me in advance)



Friday 30th April 1999
----------------------

Replaced image with a larger, clearer one. You can now read all the print on the button, including the erase and
module buttons

Found a fault which makes the image the wrong size on certain pcs, which has puzzled me, but I'll fix it (no doubt)
its just a matter of time

Fixed a bug in words(0) playing as a windows ping instead of a word



Thursday 29th April 1999
------------------------

First working version

Spelling system is working, with 30+ words! we scanned a real speak and spell today so now we have a good image to
use. The Image we currently use isnt that good, but it will do for now, its pretty clear!

All the buttons work, although most of the top row dont do anything (yet)
It will throw words at you all night! On the real thing, it gives you a score after 10 words, which I'll do at some
point.

Got correct, wrong and try again working 100% without hiccups (on my machine anyway)

Uhm

Wrote this document :)



Wednesday 28th April 1999
-------------------------

Sampled most of the sounds from the real speak and spell and got a version sort of working without a display, more 
of a wave player than anything else, but I dont know Visual Basic so I guess thats OK



Tuesday 27th April 1999
-----------------------

Re-Installed Microsoft Visual Basic and wished I hadnt after only a few minutes!

